//+------------------------------------------------------------------+
//|                                                 SilverTrend .mq4 |
//|                             SilverTrend  rewritten by CrazyChart |
//|                                                 http://viac.ru/  |
//|                  modified by Kalenzo bartlomiej.gorski@gmail.com |
//|                  modified yet again by monkey nuts (Lowphat)     |
//| RK- Modified & Added lines July 10, 2015 
//+------------------------------------------------------------------+
#property copyright "SilverTrend  rewritten by CrazyChart"
#property link      "http://viac.ru/ "

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Lime  
#property indicator_color2 Red
#property indicator_maximum 2
#property indicator_minimum -2


extern int       SSP    = 9;
extern double    Kmax   = 50.6; 
extern int  CountBars   =300;

extern bool   verticalLinesVisible     = true;
extern string LineIdentifier           = "Trendlines";
extern color  verticalLinesUpColor     = DeepSkyBlue;
extern color  verticalLinesDownColor   = Red; //PaleVioletRed;
extern int    verticalLinesStyle       = STYLE_DOT;
extern int    verticalLinesWidth       = 0;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtHBuffer1[];
double ExtHBuffer2[];
double trend[];



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorDigits (5);
   IndicatorBuffers(4);
   SetIndexStyle(0,DRAW_HISTOGRAM,0,2);SetIndexLabel(0,"FxTrd-bo-Up");  //Red
   SetIndexBuffer(0,ExtHBuffer1);
   SetIndexStyle(1,DRAW_HISTOGRAM,0,2);SetIndexLabel(1,"FxTrd-b1-Dn");     //Aqua
   SetIndexBuffer(1,ExtHBuffer2);
   
   SetIndexBuffer(2,ExtMapBuffer1);SetIndexLabel(2,"FxTrd-b2-map");
   SetIndexBuffer(3,ExtMapBuffer2);SetIndexLabel(3,"FxTrd-b3-map");
   SetIndexBuffer(4,trend);SetIndexLabel(4,"FxTrd-b4-trend");
   
   IndicatorShortName("FxTrend ("+SSP+") ("+Kmax+")");
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
     if(verticalLinesVisible) deleteLines(); 
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
 
  if (CountBars>=Bars) CountBars=Bars;
  
   SetIndexDrawBegin(0,Bars-CountBars+SSP);
   SetIndexDrawBegin(1,Bars-CountBars+SSP);
   
  int i, counted_bars=IndicatorCounted();
  double SsMax, SsMin, smax; // smin,
  
  if(Bars<=SSP+1) return(0);

if(counted_bars<SSP+1)
   {
      for(i=1;i<=SSP;i++) ExtMapBuffer1[CountBars-i]=0.0;
      for(i=1;i<=SSP;i++) ExtMapBuffer2[CountBars-i]=0.0;
   }

for(i=CountBars-SSP;i>=0;i--) { 


  SsMax = High[Highest(NULL,0,MODE_HIGH,SSP,i-SSP+1)]; 
  SsMin = Low[Lowest(NULL,0,MODE_LOW,SSP,i-SSP+1)]; 
  
   
   smax = SsMax-(SsMax-SsMin)*Kmax/100;
       
   ExtMapBuffer1[i-SSP+6]=smax; 
   ExtMapBuffer2[i-SSP-1]=smax; 

}
   for(int b=CountBars-SSP;b>=0;b--)
   {

      if(ExtMapBuffer1[b]>ExtMapBuffer2[b])
      {
         ExtHBuffer1[b]=1;
         ExtHBuffer2[b]=0;
         trend[b] = 1;
      }
      else
      {
         ExtHBuffer1[b]=0;
         ExtHBuffer2[b]=-1;
         trend[b] = -1;
      }
     
     
     
     manageLines(b); 
   }

return(0);
}

//+-------------------------------------------------------------------
//| Rk Added July 10, 2015                                                                  
//+-------------------------------------------------------------------

void manageLines(int b)
{
   if (verticalLinesVisible )
   //for(int b=CountBars-SSP;b>=0;b--)
   {
       deleteLines(Time[b]);
       if (ExtHBuffer1[b] !=ExtHBuffer1[b+1])
       {  
         if (ExtHBuffer1[b]==1 && ExtHBuffer2[b]==0)  drawLines(b,verticalLinesUpColor);
         if (ExtHBuffer1[b]==0 && ExtHBuffer2[b]==-1) drawLines(b,verticalLinesDownColor);
        } 
    /*     if (trend[i]!=trend[i+1])
         {
            if (trend[i+1] == -1 && trend[i] !=-1) drawLines(i,verticalLinesUpColor);
            if (trend[i+1] ==  1 && trend[i] != 1) drawLines(i,verticalLinesDownColor);
         }
      */   
   }
}               

//
//
//
//
//

void drawLines(int i,color theColor)
{
    string name = LineIdentifier+":"+Time[i];
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_VLINE,0,Time[i],0);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         ObjectSet(name,OBJPROP_STYLE,verticalLinesStyle);
         ObjectSet(name,OBJPROP_WIDTH,verticalLinesWidth);
         ObjectSet(name,OBJPROP_BACK,true);
}

//
//
//
//
//
void deleteLines()
{
   string lookFor       = LineIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}
void deleteLines(datetime time)
{
   string lookFor = LineIdentifier+":"+time; ObjectDelete(lookFor);
}

